package com.welchsoftwaredevelopers.myapplication;

import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.support.v7.widget.Toolbar;
import android.util.Log;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.widget.TextView;
import android.widget.Toast;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.List;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

public class MainActivity extends AppCompatActivity {
    private ArrayList<HashMap<String, List>> script;
    private ArrayList<String> ScriptQuestion;
    private Boolean clear = false;

    public MainActivity() {
        script = new ArrayList<>();
        ScriptQuestion = new ArrayList<>();
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        Toolbar toolbar = (Toolbar) findViewById(R.id.toolbar);
        setSupportActionBar(toolbar);

        try {
            String str = convertStreamToString(getResources().openRawResource(R.raw.script));
            JSONArray test = new JSONArray(str);
            readJson(test);
            Log.d("D", "test");
            Log.d("D", "script var: " + script.toString());
            Log.d("D", "script question: " + ScriptQuestion.toString());
        } catch (JSONException | IOException e) {
            e.printStackTrace();
        }
    }

    @Override
    protected void onStart() {
        super.onStart();

        Intent intent = getIntent();
        Integer count = intent.getIntExtra(getString(R.string.Total), 0);
        SharedPreferences sharedPref = MainActivity.this.getPreferences(Context.MODE_PRIVATE);
        if (sharedPref.getInt(getString(R.string.Total), 0) < count) {
            SharedPreferences.Editor editor = sharedPref.edit();
            editor.putInt(getString(R.string.Total), count);
            editor.commit();
        }
        if (intent.getBooleanExtra("Clear", false)) {
            Clear();
        }
        clear = false;


        Integer Total = sharedPref.getInt(getString(R.string.Total), 0);
        ((TextView) findViewById(R.id.main_textView_Total)).setText(Total.toString());
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        MenuInflater inflater = getMenuInflater();
        inflater.inflate(R.menu.main, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle item selection
        switch (item.getItemId()) {
            case R.id.clearMenu:
                Clear();
                return true;
            default:
                return super.onOptionsItemSelected(item);
        }
    }

    public void readJson(JSONArray ScriptObject) throws JSONException {
        Integer length = ScriptObject.length();
        Log.d("D", "length: " + length.toString());
        for (int i = 0; i < length; i++) {
            Log.d("D", "test loop" + length.toString() + ": " + ((Integer) i).toString());
            JSONObject question = ScriptObject.getJSONObject(i);
            Log.d("D", "current question object: " + question.toString());

            JSONArray opts = question.getJSONArray("opts");
            Integer length1 = opts.length();

            ScriptQuestion.add(question.getString("question"));
            Log.d("D", "current question string: " + question.getString("question"));

            List<String> optText = new ArrayList<>(length1);
            List<Integer> optDestination = new ArrayList<>(length1);
            for (int x = 0; x < length1; x++) {
                Log.d("D", "test inner loop" + length1.toString() + ": " + ((Integer) x).toString());
                JSONObject tempOpt = opts.getJSONObject(x);
                Log.d("D", "opts object: " + tempOpt.toString());
                optText.add(tempOpt.getString("Text"));
                optDestination.add(tempOpt.getInt("Destination"));
            }
            HashMap<String, List> tmp = new HashMap<>();
            tmp.put("Text", optText);
            tmp.put("Destination", optDestination);
            script.add(tmp);
        }

    }

    //http://www.java2s.com/Code/Java/File-Input-Output/ConvertInputStreamtoString.htm
    public static String convertStreamToString(InputStream is) throws IOException {
        BufferedReader reader = new BufferedReader(new InputStreamReader(is));
        StringBuilder sb = new StringBuilder();
        String line;
        while ((line = reader.readLine()) != null) {
            sb.append(line).append("\n");
        }
        reader.close();
        return sb.toString();
    }

    public static String getStringFromFile(String filePath) throws IOException, FileNotFoundException {
        File fl = new File(filePath);
        FileInputStream fin = new FileInputStream(fl);
        String ret = convertStreamToString(fin);
        //Make sure you close all streams.
        fin.close();
        return ret;
    }

    public void ClickClear(View v) {
        Clear();
    }

    public void Clear() {
        clear = true;
        ((TextView) findViewById(R.id.main_textView_Total)).setText("0");
        SharedPreferences sharedPref = MainActivity.this.getPreferences(Context.MODE_PRIVATE);

        SharedPreferences.Editor editor = sharedPref.edit();
        editor.putInt(getString(R.string.Total), 0);
        editor.commit();
    }

    public void Click(View v) {
        Intent intent = new Intent(this, ChoiceActivity.class);
        intent.putStringArrayListExtra("Questions", ScriptQuestion);
        intent.putExtra("Size", script.size());
        intent.putExtra("Next", 0);
        intent.putExtra("Clear", clear);

        Iterator<HashMap<String, List>> iter1 = script.iterator();
        Integer i = 0;
        while (iter1.hasNext()) {
            String nameOpts = "Opts" + i.toString();
            intent.putExtra(nameOpts, iter1.next());
            i++;
        }
        startActivity(intent);

    }

}
